#define defaultmaxpacketlength 25

#define TWI_SLAVE_RECV 0x10
#define TWI_OVERFLOW 0x01
#define TWI_MSTR_RECV 0x20

#define TWIS_MSTR_READSLAVE 0x30
#define TWIS_MSTR_WRITESLAVE 0x40



struct twi_packet {
    unsigned char from; // unimplemented in this version.
    unsigned char to;
    unsigned int packet_type;
    unsigned int length;
    unsigned char * data;
};

    

typedef void (*recieve)(struct twi_packet *);
typedef void (*rts)(void);
//typedef unsigned int (*transmit)(unsigned char *,unsigned char,int );



void twi_init_master();
void twi_init(unsigned char address,int general,unsigned char bitrate,unsigned char maxlength);
void twi_init_slave(unsigned char address, char general);
//unsigned char twi_read();
void setRecieveFunc(recieve);
void setRTSFunc(rts);
char twi_write(struct twi_packet *,int block);

