/* 
  Header file for spi eeprom control. Originally designed for the AT25-128
*/
#define EEPROM_READOPCODE  3
#define EEPROM_WRITEOPCODE  2
#define EEPROM_WRENOPCODE  6
#define EEPROM_RDSROPCODE  5
#define EEPROM_NOOP  EEPROM_RDSROPCODE


void init_spi_master(); // Initialize your device as the master device.
unsigned char readEeprom(unsigned int);
char writeEeprom(unsigned int,unsigned char);
char writeEnable(char );
unsigned char getReadStatus();




